/*ƵʵʱӦóӿͷļ*/
#ifndef PORT_AUDIO_H
#define PORT_AUDIO_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef enum {
        paNoError = 0,

        paHostError = -10000,
        paInvalidChannelCount,
        paInvalidSampleRate,
        paInvalidDeviceId,
        paInvalidFlag,
        paSampleFormatNotSupported,
        paBadIODeviceCombination,
        paInsufficientMemory,
        paBufferTooBig,
        paBufferTooSmall,
        paNullCallback,
        paBadStreamPtr,
        paTimedOut,
        paInternalError
} PaErrorNum;

/*1.ĳʼʹÿ֮ǰҪȵøú*/
int Pa_Initialize( void );

/*2.ֹʹÿ֮Ҫøú*/
int Pa_Terminate( void );

/*3.ش뺯*/
long Pa_GetHostError( void );

/*4.Ϊ˿ɶϢ*/
const char *Pa_GetErrorText( int errnum );

/*(1)ݵĸʽ*/
#define paFloat32      ((unsigned long) (1<<0))        
#define paInt16        ((unsigned long) (1<<1))        
#define paInt32        ((unsigned long) (1<<2))        
#define paInt24        ((unsigned long) (1<<3))
#define paPackedInt24  ((unsigned long) (1<<4))
#define paInt8         ((unsigned long) (1<<5))
#define paUInt8        ((unsigned long) (1<<6))    
#define paCustomFormat ((unsigned long) (1<<16))

#define paNoDevice -1
/*(2)Ϣ*/
typedef struct{
        int structVersion;
        const char *name;
        int maxInputChannels;
        int maxOutputChannels;
        int numSampleRates;
        const double *sampleRates;
        unsigned long nativeSampleFormats;
} PaDeviceInfo;

/*5.*/
int Pa_CountDevices();
    
/*6.Ĭϵ*/
int Pa_GetDefaultInputDeviceID( void );
    
/*7.Ĭϵ*/
int Pa_GetDefaultOutputDeviceID( void );

/*8.ô洢Ϣַ*/
const PaDeviceInfo* Pa_GetDeviceInfo( int devID );

/*9.ص˵
 inputBuffer and outputBufferݡʽ洢ͨ
 framesPerBuffer֡
 outTime()ʱ䡣
 userData͵ݡ
*/
typedef int (PortAudioCallback)(
                void *inputBuffer, void *outputBuffer,
                unsigned long framesPerBuffer,
                double outTime, void *userData );


/*(3)Զ*/
#define   paNoFlag      (0)
#define   paClipOff     (1<<0)   
#define   paDitherOff   (1<<1)   
#define   paPlatformSpecificFlags (0x00010000)

/*10.˵ͬʱ򿪺*/
int Pa_OpenStream( void** stream,
                       int inputDevice,
                       int numInputChannels,
                       unsigned long inputSampleFormat,
                       void *inputDriverInfo,
                       int outputDevice,
                       int numOutputChannels,
                       unsigned long outputSampleFormat,
                       void *outputDriverInfo,
                       double sampleRate,
                       unsigned long framesPerBuffer,
                       unsigned long numberOfBuffers,
                       unsigned long streamFlags,
                       PortAudioCallback *callback,
                       void *userData );


/*11.Ĭϵˣͬʱ򿪺*/
int Pa_OpenDefaultStream( void** stream,
                                int numInputChannels,
                                int numOutputChannels,
                                unsigned long sampleFormat,
                                double sampleRate,
                                unsigned long framesPerBuffer,
                                unsigned long numberOfBuffers,
                                PortAudioCallback *callback,
                                void *userData );

/*12.رջ*/
int Pa_CloseStream( void* );

/*13.ʼ*/
int Pa_StartStream( void *stream );
    
/*14.ֹҪȻݿպ*/
int Pa_StopStream( void *stream );
    
/*15.ֹȻݿպ*/
int Pa_AbortStream( void *stream );

/* 16.״أֵڽУֵûڽУ
 ֵЧ*/
int Pa_StreamActive( void *stream );

/*17.Ҫõʱ亯*/
double Pa_StreamTime( void *stream );

/*18.ռCPUٷֱȺ0.5ʾռ50%*/
double Pa_GetCPULoad( void* stream );

/*18.С*/
int Pa_GetMinNumBuffers( int framesPerBuffer, double sampleRate );

/*19.ͣ΢루msecλ*/
void Pa_Sleep( long msec );
    
/*20.bytesʾĲݴС*/
int Pa_GetSampleSize( unsigned long format );

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* PORT_AUDIO_H */


#include <math.h>
//#ifndef M_PI
//#define M_PI  (2*asin(1))
//#endif
const double M_PI=2*asin(1.0);